// ChildView.cpp : implementation of the CChildView class
//

#include "stdafx.h"
#include "TrigFuncGraph.h"
#include "ChildView.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CChildView

CChildView::CChildView()
{
    m_bPlotSinSeries = true;
    m_bPlotCosSeries = true;
    m_bPlotTanSeries = true;
}

CChildView::~CChildView()
{
}


BEGIN_MESSAGE_MAP(CChildView, CWnd)
	ON_WM_PAINT()
END_MESSAGE_MAP()



// CChildView message handlers

BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW), reinterpret_cast<HBRUSH>(COLOR_WINDOW+1), NULL);

	return TRUE;
}

void CChildView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

    CRect rect;
    GetClientRect(rect);

    int margin = 50;
    int width = rect.Width() - margin;
    int height = rect.Height() - margin;

    //dc.MoveTo(0 + margin / 2, 0 + margin / 2);
    //dc.LineTo(0 + margin / 2, height + margin / 2 );
    dc.Rectangle(0 + margin / 2, 0 + margin / 2, width + margin / 2, height + margin / 2);

    dc.MoveTo(0 + margin / 2, margin / 2 + height / 2);
    dc.LineTo(width + margin / 2, margin / 2 + height / 2);

    double legendypos = margin;
    double legendxpos = margin;

	static const double PI = 3.1415926535;
	if(m_bPlotSinSeries == true)
    {
        for(double i = 0; i <= 720.01; i += 0.01)
        {
            double value = sin(i * PI / 180);
            value += 1.0;
            int ypos = value / 2 * height + margin / 2;
            int xpos = i / 720.0 * width + margin / 2;
            dc.SetPixel(xpos, ypos, RGB(255, 0, 0));
            if( (int(i) % 90) == 0)
            {
                dc.MoveTo(xpos, margin / 2 + height / 2 - 5);
                dc.LineTo(xpos, margin / 2 + height / 2 + 5);
                char buf[32];
                sprintf(buf, "%d", int(i));
                dc.TextOut(xpos - 10, margin / 2 + height / 2 + 10, buf);

            }
        }
        dc.SetTextColor(RGB(255,0,0));
        dc.TextOut(legendxpos, legendypos, "SIN Series - RED Color");
        legendypos += 20;
    }

    if(m_bPlotCosSeries == true)
    {
        for(double i = 0; i <= 720.01; i += 0.01)
        {
            double value = cos(i * PI / 180);
            value += 1.0;
            int ypos = value / 2 * height + margin / 2;
            int xpos = i / 720.0 * width + margin / 2;
            dc.SetPixel(xpos, ypos, RGB(0, 255, 0));
            if( (int(i) % 90) == 0)
            {
                dc.MoveTo(xpos, margin / 2 + height / 2 - 5);
                dc.LineTo(xpos, margin / 2 + height / 2 + 5);
                char buf[32];
                sprintf(buf, "%d", int(i));
                dc.TextOut(xpos - 10, margin / 2 + height / 2 + 10, buf);
            }
        }
        dc.SetTextColor(RGB(0,255,0));
        dc.TextOut(legendxpos, legendypos, "COS Series - Green Color");
        legendypos += 20;
    }
    
    if(m_bPlotTanSeries == true)
    {
        double factor = 10; // Don't use this factor, it is only for drawing purpose.
        for(double i = 0; i <= 720.01; i += 0.01)
        {
            double value = tan(i * PI / 180);

            if(value > factor)
                value = factor;
            if(value < -factor)
                value = -factor;
            value += factor;
            int ypos = value / (factor * 2) * height + margin / 2;
            int xpos = i / 720.0 * width + margin / 2;
            dc.SetPixel(xpos, ypos, RGB(0, 0, 255));
            if( (int(i) % 90) == 0)
            {
                dc.MoveTo(xpos, margin / 2 + height / 2 - 5);
                dc.LineTo(xpos, margin / 2 + height / 2 + 5);
                char buf[32];
                sprintf(buf, "%d", int(i));
                dc.TextOut(xpos - 10, margin / 2 + height / 2 + 10, buf);
            }
        }
        dc.SetTextColor(RGB(0,0,255));
        dc.TextOut(legendxpos, legendypos, "TAN Series - Blue Color");
        legendypos += 20;
    }
}

